; Bernhard.Erfurt@gmx.de						
; 01/2021										
;												
;												
; 128 x 64 Pixel=8.192 Pixel :8=1024			
; ATmega8 										
; 8MHz											
.include "m8def.inc"
.include "MACROS.asm"
.equ TAKT							= 8000000	; 8 MHz
; ERROR CODES									
.equ ERROR_TWI_MT_START			=0x20
.equ ERROR_TWI_MT_SLA			=0x21
.equ ERROR_TWI_MT_DATA			=0x22
.equ ERROR_TWI_MR_START			=0x23
.equ ERROR_TWI_MR_SLA			=0x24
.equ ERROR_TWI_MR_DATA			=0x25
.equ ERROR_TWI_MR_DATAEND		=0x26

; LED-GRUEN										
.equ LED_GRUEN_PIN_NR				= 0
.equ LED_GRUEN_DDR					= DDRD
.equ LED_GRUEN_PORT					= PORTD
; LED-GELB										
.equ LED_GELB_PIN_NR				= 1
.equ LED_GELB_DDR					= DDRD
.equ LED_GELB_PORT					= PORTD
; LED-ROT										
.equ LED_ROT_PIN_NR					= 2
.equ LED_ROT_DDR					= DDRD
.equ LED_ROT_PORT					= PORTD
; REGISTER										

.def TIMERWERT2		= R5
.def UHR_COUNTER_L	= R6
.def UHR_COUNTER_H	= R7
.def KOPIE_SREG		= R8
.def KOPIE_TEMP		= R9
.def OLED_X 		= R10
.def OLED_Y 		= R11
.def ERROR	= R12
.def NULL 	= R13
.def EINS 	= R14
.def VOLL 	= R15
.def temp 	= R16
.def temp1 	= R17
.def temp2 	= R18
.def temp3 	= R19
.def temp4 	= R20
.def temp5 	= R21
.def temp6 	= R22
.def temp7 	= R23
.def temp8 	= R24
.def temp9 	= R25

; SRAM-BELEGUNG										
.equ adr_DATEN						= SRAM_START		; 0x0060 START Adresse 						

.equ adr_ss							=SRAM_START+20	; Sekunden					
.equ adr_mm							=SRAM_START+21	; Minuten					
.equ adr_hh							=SRAM_START+22	; Stunden

.equ adr_STOP_UHR_L					=SRAM_START+30
.equ adr_STOP_UHR_H					=SRAM_START+31
.equ adr_STOP_UHR_ERGEBNIS_L		=SRAM_START+32
.equ adr_STOP_UHR_ERGEBNIS_H		=SRAM_START+33

.equ adr_FREQ_i						=SRAM_START+34
.equ adr_FREQ0						=SRAM_START+35
.equ adr_FREQ1						=SRAM_START+36
.equ adr_FREQ2						=SRAM_START+37


.equ adr_ADC_BETRIEBSSPANNUNG		=SRAM_START+40

.equ adr_ASCII_FONT					= SRAM_START+50
.equ adr_ASCII_BEREICH_OZ			= SRAM_START+51	; obere  Zeile				
.equ adr_ASCII_BEREICH_UZ			= SRAM_START+70 ; untere Zeile				


.equ adr_TWI_ADR					= SRAM_START+100
.equ adr_TWI_BEREICH				= SRAM_START+101	; BEREICH fr Master TWI/I2C	
.equ adr_SRAM_CHECK					= SRAM_START+900	; Programm-Check	
.equ adr_SRAM_ENDE					= SRAM_START+1023


.cseg					;Beginn eines Code-Segmentes
.org 0					;Startadresse=0

rjmp RESET      		; Reset Handler                           				
rjmp INTERRUPT_ERROR	;rjmp EXT_INT0   		; IRQ0 Handler                  
rjmp INTERRUPT_ERROR	;rjmp EXT_INT1   ; IRQ1 Handler                      	
rjmp INTERRUPT_ERROR	;rjmp TIM2_COMP  ; Timer2 Compare Handler            	
rjmp TIM2_OVF   ; Timer2 Overflow Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_CAPT  ; Timer1 Capture Handler            	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPA ; Timer1 CompareA Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPB ; Timer1 CompareB Handler           	
rjmp TIM1_OVF   ; Timer1 Overflow Handler       		
rjmp INTERRUPT_ERROR	;rjmp TIM0_OVF   		; Timer0 Overflow Handler       
rjmp INTERRUPT_ERROR	;rjmp SPI_STC    ; SPI Transfer Complete Handler     	
rjmp INTERRUPT_ERROR 	; USART RX Complete Handler         					
rjmp INTERRUPT_ERROR	;rjmp USART_UDRE ; UDR Empty Handler                 	
rjmp INTERRUPT_ERROR	;rjmp USART_TXC  ; USART TX Complete Handler         	
rjmp INTERRUPT_ERROR	;rjmp ADC        ; ADC Conversion Complete Handler   	
rjmp INTERRUPT_ERROR	;rjmp EE_RDY     ; EEPROM Ready Handler              	
rjmp INTERRUPT_ERROR	;rjmp ANA_COMP   ; Analog Comparator Handler         	
rjmp INTERRUPT_ERROR	;rjmp TWSI       ; Two-wire Serial Interface Handler 	
rjmp INTERRUPT_ERROR	;rjmp SPM_RDY    ; Store Program Memory Ready Handler	


; Interrupt-ERROR						
INTERRUPT_ERROR:
	LED_ROT_ON
	LED_GELB_ON
	LED_GRUEN_ON
	rcall WAIT_100ms
	LED_ROT_OFF
	LED_GELB_OFF
	LED_GRUEN_OFF
	rcall WAIT_100ms
	rjmp INTERRUPT_ERROR
RESET:                        
	ldi temp, LOW(RAMEND)						; STACK initialisieren
    out SPL, temp
    ldi temp, HIGH(RAMEND)
    out SPH, temp
	rcall Watchdog_aktivieren
	rcall SRAM_CLEAR
	rcall STARTWERTE
	rcall PORT_CLEAR
	rcall PORT_INITIALISIERUNG
	rcall TWI_INI
	rcall ADC_INITIALISIERUNG
	rcall TIMER1_FREQUENZZAEHLER_INITIALISIERUNG
	rcall TIMER2_100us_INITIALISIERUNG
	rcall TIMER_AKTIVIEREN
	rcall PROGRAMM_CHECK
	sei											; interrupts freigeben
	LED_GRUEN_ON
;-------------------------------------------------------------------------------
	rcall TWI_OLED_INITIALISIERUNG
	rcall OLED_VOLL
	rcall WAIT_100ms
	rcall OLED_CLEAR
	rcall WAIT_100ms
	rcall ANZEIGE_BEGRUESSUNG
	rcall WAIT_1s
	rcall OLED_CLEAR


	rcall OLED_TEST1
	rcall WAIT_1s
	rcall OLED_CLEAR

	rcall TWI_SCAN
	rcall WAIT_1s
	rcall OLED_CLEAR

	rcall OLED_TEST2
	rcall WAIT_1s
	rcall OLED_CLEAR
; ##############################################################################
; ##############################################################################
; ##############################################################################
LOOP:
	wdr
	rcall PROGRAMM_CHECK
	rcall ADC_BETRIEBSSPANNUNG_TEMP1
	rcall ANZEIGE_HAUPT		
	rcall WAIT_100ms
rjmp LOOP
; ##############################################################################
; ##############################################################################
; ##############################################################################
.include "ADC.asm"
.include "ASCII.asm"
.include "ANZEIGE.asm"
.include "TIMER.asm"
.include "TWI.asm"
.include "TWI_OLED.asm"
.include "SONSTIGES.asm"
.include "WAIT.asm"
.include "ZAHLEN.asm"

TEXT_BEGRUESSUNG_1:
.db "OLED ATmega328p",0
TEXT_BEGRUESSUNG_2:
.db "01/2021 V6 ",0
TEXT_BEGRUESSUNG_3:
.db "128x64 Pixel ",0
TEXT_BEGRUESSUNG_4:
.db "8 MHz",0

TEXT_SCAN:
.db "SCAN...",0

TEXT_CLEAR:
.db "CLEAR",0

TEXT_FERTIG:
.db "fertsch",0
